## アニメーション作成用ライブラリのロード。
## animation の動作には ImageMagick が必要。
## http://www.imagemagick.org/
#install.packages("animation")
library(animation)
library(MASS)

## 正規分布に従う標本の平均値がばらつく様子。
plotBell <- function()
{
	plot(function(x) dnorm(x, 0, 1), xlim = c(-3, 3), ylab = "")
}
sampleAnimation <- function()
{
	for (loop in 1 : 20)
	{
		plotBell()
		x <- rnorm(30, 0, 1)
		rug(x)
		abline(v = mean(x), lty = "dotted")
	}
}
#png("sample.png")
#plotBell()
#dev.off()
saveMovie(sampleAnimation(), interval = 0.5, outdir = getwd(), moviename = "sample", movietype = "mp4")

## GLM のパラメトリックブートストラップ。
u <- c(5, 10, 15, 20, 30, 40, 60, 80, 100)
lot1 <- c(118, 58, 42, 35, 27, 25, 21, 19, 18)
model <- glm(lot1 ~ log(u), family = Gamma)
shape <- gamma.shape(model)$alpha
scale <- model$fitted.values / shape
x <- seq(min(log(u)) - 0.1, max(log(u)) + 0.1, length.out = 300)

plotModel <- function(model)
{
	plot(model$formula, ylim = c(0, 140), ylab = "lot")
	lot.predict <- model$family$linkfun(model$coefficients[1] + model$coefficients[2] * x)
	lines(x, lot.predict)
}
bootstrapAnimation <- function()
{
	for (loop in 1 : 20)
	{
		bootstrapModel <- glm(model$family$simulate(model, 1) ~ log(u), family = Gamma)
		plotModel(bootstrapModel)
	}
}
#png("parametric.png")
#plotModel(model)
#dev.off()
saveMovie(bootstrapAnimation(), interval = 0.5, outdir = getwd(), moviename = "parametric", movietype = "mp4")
